# Electronics Production

## Introduction

I have worked with a CNC milling machine for my graduation project, at that time my instructor told me about using the CNC machine to produce a PCB since that I was curious about it. In this day I have learned about the PCB milling machine.

## Design and milling

#### Machine set up

The day started by the design of the programmer. I have not designed it instead, I have downloaded it as a png picture. This website [fabmodules](http://fabmodules.org/) is where the picture is converted to `.rml` format.

After the picture has been converter to the required format, I have started to set up the machine which is the SRM-20 machine.

The following images show the process of setting up the machine and preparing the spindle.

![](images/1.jpg)

![](images/2.jpg)

FR1 paper is used to produce the PCB, for the programmer one side paper is used, but for more complicated designs double side paper could be used. There are other types of paper like the FR4, but it is not recommended. When I was preparing the paper, I have hold it in the wrong way. My fingerprint can be seen in the following image, this may cause a short circuit if any design is produced over it.

The following photo also shows a number of milling bits. For the traces 1/64" bit will be used whereas 1/32" bit for the cover both are two flutes with the spindle diameter of 3.175mm. The cutting part of the bit must not too tall so that it does not break during the operation especially the traces bit.

![](images/3.jpg)

The following image shows a rigid box of foam, this box is placed inside the machine because the bit can not go down in the z-axis and reach the paper. The following pictures show the process of placing the paper on the foam with a double face tape. During this process, I have checked several time for any bubbles. These bubbles will cause the surface to be uneven and may cause the bit to break.

![](images/4.jpg)

Next step was to place the milling bit, this process is very sensitive, so the first thing to do was placing a sheet of cartoon over the FR1 paper to protect the bit if it falls down during the installation process. I have used two fingers also as shown in the following image to make sure the bit does not fall. I have fixed bit so that at least 20% of the spindle is visible for the purpose of setting up the zero z-axis.


![](images/5.jpg)

#### Downloading the software

After setting up the SRM-20, I have downloaded the software starting from [this link](startup.rolanddg.com), I have opened an account on roland support to be able to download the software.

#### Producing the design

Now the machine is connected to the computer. Before doing anything or starting any operation, the origin should be set. There are two coordinates, user and machine coordinated. User coordinate system should be zero in all directions then the milling operation can be started.

Last step is to remove the programmer from the FR1 paper, this can be done using a screw driver. The programmer must be removed easily otherwise start the operation again with a deeper z-axis. Fortunately the programmer is removed from the first time.  

![](images/6.jpg)

#### Problem with the design

The first programmer had a short circuit, the problem is that the picture of the design is 600dpi so to solve this problem I have downloaded another picture for the same design, but with higher dpi. It was 1000 dpi.

#### Increase USB thickness

## Soldering and testing

ِAfter I have produced the PCB, I have started soldering the components. All the components are surface mounted which means that the component will not fit inside a hole, instead it will soldered on the PCB surface directly.

To start soldering, frist thing I did is preparing the soldering station. I have a solder station which needs a 110V input so I needed a transformer to covert the 220v output to the needed 110v.

![](images/7.jpg)

Next, I have prepared the parts:

1. x1 ATiny 45 micro controller.
2. x2 1K ohm resistors.
3. x2 500 ohm resistors.
4. x2 50 ohm resistors.
5. x2 3.3v Zener diode.
6. x1 Red LED.
7. x1 Green LED, I have used Blue since I don't have Green.
8. x1 100nF Capacitor.
9. x1 2x3 Connector.

#### Soldering

It not my first time to solder parts, actually I have soldered through hole components before, but this is my first time to solder surface mounted devices (SMD). The following image shows SMD soldering procedure.

![](images/10.jpg)

One of the major differences I have found between through hole and SMD is that the component legs in the SMD is very small. I tired to use the magnifying glasses, but I found it difficult to solder so I relied on my naked eyes.

![](images/9.jpg)

After I have soldered the components, I have tested the functionality by inspecting a short circuit and if the circuit is closed or not using a multimeter. The multimeter will make a beep sound if the circuit is closed.

I had four soldering defects, all in which the components were not soldered properly. The following images shows the defects.

500 ohm and the second leg of the micro controller were not soldered properly.

![](images/11.jpg)

The diode and the 50 ohm resistor were also not soldered properly.

![](images/12.jpg)

Another check I have did is to plug the usb to a USB port, the Red LED was illuminated.


#### Programming

Now that my programmer is ready to be programmed,

![](images/13.jpg)

I have installed the toolchain and the firmware using the following steps. First run the command `sudo apt install avrdude gcc-avr avr-libc make`, then I have downloaded the firmware from [this link](http://fab.cba.mit.edu/classes/863.16/doc/projects/ftsmin/fts_firmware_bdm_v1.zip), after that, I have opened the firmware directory using the command `cd "directory"` then I have executed the following command `make` to make the .hex file which will be uploaded to the miro controller.

To upload the .hex file, I will use atmelice so I have opened the **Makefile** using atom and changed the **PROGRAMMER** to atmelice then I have executed the following commands `make flash`, `make fuses`, `make rstdisbl`, `make rstdisbl`.

![](images/14.jpg)

During this process, I have faced a problem which states that there is a problem with the connection, I have looked for a solution and found it in [this link](http://archive.fabacademy.org/2017/fablabspinderihallerne/students/63/week4.html). The solution was to change the **PROGRAMMER** to atmelice_isp instead of atmelice.

#### Testing

My board is now a programmer, to the functionality of it, my classmates boards have used it to program their boards. They have followed the same procedure, but the **PROGRAMMER** was changed from atmelice_isp to usbtiny.

The following images show the procedure of making the connector cable so that my programmer could be used to program other boards.

![](images/15.jpg)

One end of the cable must be twisted then inserted as shown in the following below.

![](images/16.jpg)

#### Desolder the components

A heat gun is used to remove the soldered components, this gun heats air up to 400 degreed celius. The component should be holded by a tweezers during the process. The heat gun should be switched to cold air before shutting it down so that all the heat inside the gun is removed.

![](images/17.jpg)

## Design a PCB

The programmer was a pre-designed circuit, but now it is time to design and produce my own circuit. The PCB has a very simple design, a LED controlled by a button.

The components are:

1. ATtiny 44
2. 10K ohm resistor
3. 1uf Capacitor
4. Red LED
5. 100 ohm resistor
6. Button
7. FTDI connector
8. 2x3 connector

#### Kokopelli

Kokopelli is a software to design a PCB using python. I have not designed the circuit from scratch because it will take me a lot of time, instead I have modified a previous design.

I have downloaded the software from this [link](https://github.com/TheBeachLab/kokoretro), and then used the command `make fab` to compile all the files and then opened the bin folder by the command `cd bin` and finally started the software using the command `./kokopelli -r`

![](images/koko.png)

#### Producing my first board

#### Programming
